/* stdio.h */

#if (defined(WIN32_PLATFORM_PSPC) && (_WIN32_WCE >= 300)) || defined(x86)
#include <stdio.h>
#else



#ifndef __STDIO_H__
#define __STDIO_H__

/* For the benefit of clients */

#if defined(EXTERN_C_API)
# undef EXTERN_C_API
#endif

#if defined(IMPLEMENTS_STDIO)
# if defined(__cplusplus)
#  define EXTERN_C_API extern "C" __declspec(dllexport)
# else
#  define EXTERN_C_API extern __declspec(dllexport)
# endif
#else
# if defined(__cplusplus)
#  define EXTERN_C_API extern "C" __declspec(dllimport)
# else
#  define EXTERN_C_API extern __declspec(dllimport)
# endif
#endif

/* For the benefit of the implementation */

#if defined(IMPLEMENTS_STDIO) || defined(EXTENDS_STDIO)
# include "stdioimp.h"
#endif


typedef struct FILE
{
	int fActive;
#if (defined(IMPLEMENTS_STDIO) || defined(EXTENDS_STDIO)) && defined(__cplusplus)
	CXStdioStream* pstream;
#else
	void* pvStream;
#endif
} FILE;

EXTERN_C_API FILE RgStdioFiles[];
EXTERN_C_API FILE StdioStdin;
EXTERN_C_API FILE StdioStdout;

#define stdin (&StdioStdin)
#define stdout (&StdioStdout)
#define stderr (&StdioStdout)

#define EOF (-1)

/* Seek method constants */

#define SEEK_CUR    1
#define SEEK_END    2
#define SEEK_SET    0

typedef unsigned size_t;

EXTERN_C_API size_t fread( void *, size_t , size_t , FILE *);
EXTERN_C_API size_t fwrite( const void *, size_t , size_t , FILE * );
EXTERN_C_API FILE *fopen( const char *, const char * );
EXTERN_C_API int fflush( FILE *);
EXTERN_C_API int fclose( FILE *);
EXTERN_C_API int getc( FILE *);
EXTERN_C_API int putc( int c, FILE *);
EXTERN_C_API int ungetc( int c, FILE *);
EXTERN_C_API long ftell( FILE *);
EXTERN_C_API int fseek( FILE *, long , int );
EXTERN_C_API char *fgets( char *, int , FILE *);
EXTERN_C_API int fputs( const char *, FILE *);
EXTERN_C_API int __cdecl sprintf( char *buffer, const char *format, ... );
EXTERN_C_API int __cdecl fprintf( FILE *stream, const char *format, ... );
EXTERN_C_API int __cdecl printf( const char *format, ... );


// Entry point called on WM_HIBERNATE to ensure good behavior

EXTERN_C_API void StdioOnHibernate();

// Special entry point for Scheme char-ready? semantics

EXTERN_C_API int StdioCharReady(FILE*);

//$ BUGBUG why did I add this?

#ifndef _OFF_T_DEFINED
typedef long _off_t;                    /* file offset value */
#if !__STDC__
/* Non-ANSI name for compatibility */
typedef long off_t;
#endif
#define _OFF_T_DEFINED
#endif


#endif // end of file


#endif // Pocket PC