// SparkCtl.cpp : Implementation of CSparkCtl
#include "stdafx.h"
#include "piespark.h"
#include "SparkCtl.h"

void
g_getUrl(char *url, char *target, void *client_data)
{
	((CSparkCtl*)client_data)->getUrl(url, target);

}

void g_getSwf(char *url, int level, void *clientData)
{
	((CSparkCtl*)clientData)->getSwf(url, level);

}



STDMETHODIMP CSparkCtl::Load2(IPropertyBag *pPropBag, IErrorLog *pErrorLog) {
	//MessageBox(_T("Loading"));
	return S_OK;
}

STDMETHODIMP CSparkCtl::Save2(LPPROPERTYBAG pPropBag, BOOL fClearDirty, BOOL fSaveAllProperties) {
	//MessageBox(_T("Saving"));
	return S_OK;
}

/////////////////////////////////////////////////////////////////////////////
// CSparkCtl

STDMETHODIMP CSparkCtl::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_ISparkCtl,
	};
	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}


STDMETHODIMP CSparkCtl::get_PenWidth(short *pVal)
{
	*pVal = m_PenWidth;
	return S_OK;
}

STDMETHODIMP CSparkCtl::put_PenWidth(short newVal)
{
	m_PenWidth = newVal;
	return S_OK;
}

STDMETHODIMP CSparkCtl::get_Src(BSTR *p)
{
	*p = SysAllocString(m_src);
	return S_OK;
}

STDMETHODIMP CSparkCtl::put_Src(BSTR v)
{
	m_src = v;
	return S_OK;
}

STDMETHODIMP CSparkCtl::get_Quality(BSTR *p)
{
	*p = SysAllocString(m_quality);
	return S_OK;
}

STDMETHODIMP CSparkCtl::put_Quality(BSTR v)
{
	m_quality = v;
	return S_OK;
}

STDMETHODIMP CSparkCtl::get_Scale(BSTR *p)
{
	*p = SysAllocString(m_scale);
	return S_OK;
}

STDMETHODIMP CSparkCtl::put_Scale(BSTR v)
{
	m_scale = v;
	return S_OK;
}

STDMETHODIMP CSparkCtl::get_Loop(BSTR *p)
{
	*p = SysAllocString(m_loop);
	return S_OK;
}

STDMETHODIMP CSparkCtl::put_Loop(BSTR v)
{
	m_loop = v;
	return S_OK;
}

STDMETHODIMP CSparkCtl::get_BaseURL(BSTR *p)
{
	*p = SysAllocString(m_baseurl);
	return S_OK;
}

STDMETHODIMP CSparkCtl::put_BaseURL(BSTR v)
{
	m_baseurl = v;
	return S_OK;
}





long CSparkCtl::FlashGraphicInitWin32(FlashHandle flashHandle) {
	RECT wattr;
	HDC hdc;
	int pad, targetWidth, targetHeight, zoom;
	HBITMAP canvas;
	LPBYTE canvasBuffer;

	GetClientRect(&wattr);

	hdc = GetDC();
	pad = 4;//(512-480);


	targetWidth = wattr.right - wattr.left; //wattr.width;
	targetHeight = wattr.bottom - wattr.top; // wattr.height;
	if (targetWidth <= 0) targetWidth = 90;
	if (targetHeight <= 0) targetHeight = 90;

	int realWidth = targetWidth;

	if (targetWidth % 2 == 1) {
		targetWidth += 1;
	}

	TCHAR szBuf[64];
	wsprintf(szBuf, _T("%dx%d"), targetWidth, targetHeight);
	MSGDEBUG(szBuf);
	zoom = 20;

	if (m_hbmpBuffer) {
		DeleteObject(m_hbmpBuffer);
		DeleteDC(m_bufferdc);
	}

	//allocColor = allocColor16_565;

	// create canvas == DIBSection
	// TODO DIBsection code
	{
		BITMAPINFO * bmi;
		LPDWORD masks;
		bmi = (BITMAPINFO *)malloc(sizeof(BITMAPINFO)+(sizeof(RGBQUAD)*256));

		bmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		bmi->bmiHeader.biWidth = targetWidth;
		bmi->bmiHeader.biHeight = -targetHeight;
		bmi->bmiHeader.biPlanes = 1;
		bmi->bmiHeader.biBitCount = 16;
		bmi->bmiHeader.biCompression   = BI_BITFIELDS ;
		bmi->bmiHeader.biSizeImage     = targetWidth*targetHeight*2;
		bmi->bmiHeader.biXPelsPerMeter = 0;
		bmi->bmiHeader.biYPelsPerMeter = 0;
		bmi->bmiHeader.biClrUsed       = 0;
		bmi->bmiHeader.biClrImportant  = 0;
		masks = (LPDWORD)((LPBYTE)&bmi->bmiHeader + bmi->bmiHeader.biSize);

		masks[0] = 0x0000F800; //  red   (0000 0000 0000 0000 1111 1000 0000 0000)
		masks[1] = 0x000007E0; //  green (0000 0000 0000 0000 0000 0111 1110 0000)
		masks[2] = 0x0000001F; //  blue  (0000 0000 0000 0000 0000 0000 0001 1111)

		canvas = CreateDIBSection( hdc, bmi, DIB_RGB_COLORS, (void **)&canvasBuffer, NULL, 0);
		if (!canvas) {
			TCHAR buf[80];
			wsprintf(buf, _T("DIBSection error == %d, targetWidth = %d, targetHeight = %d"), GetLastError(), targetWidth, targetHeight);
			MSGDEBUG(buf);
		}

		m_hbmpBuffer = canvas;

		free(bmi);
	}
	
	m_fd.pixels = canvasBuffer;
	m_fd.width = realWidth;// + 1;
	m_fd.height = targetHeight;// + 1;
	m_fd.bpl = targetWidth * 2;
	m_fd.depth = 16;

	m_bufferdc = CreateCompatibleDC(hdc);

	SelectObject(m_bufferdc, m_hbmpBuffer);
	GetClientRect(&wattr);
	FillRect(m_bufferdc, &wattr, (HBRUSH)GetStockObject(WHITE_BRUSH));

	return FlashGraphicInit(flashHandle, &m_fd);

}

void CSparkCtl::getUrl(char* url, char* target) {

	LPTSTR szUrl = (LPTSTR)malloc(sizeof(TCHAR) * (strlen(url) + 1));
	::mbstowcs(szUrl, url, strlen(url) + 1);
	LPTSTR szTarget = (LPTSTR)malloc(sizeof(TCHAR) * (strlen(target) + 1));
	::mbstowcs(szTarget, url, strlen(target) + 1);


	if (m_pBrowser) {
		m_pBrowser->Navigate(szUrl, 0, szTarget, NULL);
	} else if (m_pWebBrowser2) {
		CComBSTR bstrTarget = szTarget;
		VARIANT v;
		v.vt = VT_BSTR;
		v.bstrVal = bstrTarget;
		m_pWebBrowser2->Navigate(szUrl, 0, &v, NULL, NULL);

	}

	free(szUrl);
	free(szTarget);

}

void CSparkCtl::getSwf(char *url, int level) {

	LPTSTR szUrl = (LPTSTR)malloc(sizeof(TCHAR) * (strlen(url) + 1));
	::mbstowcs(szUrl, url, strlen(url) + 1);

	m_src = szUrl;
	m_level = level;
//	MessageBox(szUrl, _T(""), MB_SETFOREGROUND);
	loadMovie(m_src);
	wakeUp = 1;
	::PostMessage(m_hWnd, WM_FLASHWAKEUP, 0, 0);

	//

	free(szUrl);
}


void g_getDataFromUrl(void * clidata, LPCTSTR url, char**buffer, long* size, int* status) {
//	((CSparkCtl*)clidata)->gotDataFromUrl(url, buffer, size, status);
}

int CSparkCtl::gotDataFromUrl(FlashHandle fh, LPCTSTR url, char*buffer, long size, int* lpstatus) {
	int status;

	status = FlashParse(fh, m_level, buffer, size);
	*lpstatus = status;

	if (status & FLASH_PARSE_ERROR) {
		// err
		return -1;
	}

	if (status & FLASH_PARSE_START) {
		// init!

	} 
	if (status & FLASH_PARSE_WAKEUP) {
		//OnWakeup(WM_FLASHWAKEUP, 0, 0, b); 
	}

	return 0;
}


void CSparkCtl::loadMovie(LPCTSTR themovie) {
	KillTimer(23);

	static char *buffer = NULL;
#define BUFBLOCKSIZE (1024*32)
	long size;
	int status;
	FlashHandle fh;
	HRESULT hr;

	if (themovie == NULL) {
		return;
	}


	if (flashHandle) FlashClose(flashHandle);

	fh = FlashNew();
	

	if (fh == 0) {
		exit(1);
	}

	m_zoom = 20;
	m_xoffs = m_yoffs = 0;
	flashHandle = fh;
	wakeUp = 1;

	//CMonikerFile cmf;
	IMoniker *pMk = NULL;
	IMoniker *pBase = NULL;

	MSGDEBUG(themovie);

	MSGDEBUG(_T("CURLM"));

	if (m_baseurl && lstrlen(m_baseurl)) {
		CreateURLMoniker(NULL, m_baseurl, &pBase);
	}

	CreateURLMoniker(pBase, themovie, &pMk);

	if (pBase) pBase->Release();

	if (!pMk) {
		MSGDEBUG(_T("CURLM failed"));
		return;
	}


	LPOLESTR pszDisplayName;
    CComBSTR bstrURL;

    if (SUCCEEDED(pMk->GetDisplayName(NULL, NULL, &pszDisplayName))) {
		USES_CONVERSION;

		bstrURL = pszDisplayName;

		MSGDEBUG(OLE2T(bstrURL));
     
	}

	BOOL isFile = 0;

	//MessageBox(OLE2T(bstrURL), _T("LoadMovie"));

	if (wcsnicmp(OLE2T(bstrURL), _T("file://"), lstrlen(_T("file://"))) == 0) {
		isFile = 1;
	}


	if (isFile) {
		HANDLE hFile;
		hFile = CreateFile(OLE2T(bstrURL) + lstrlen(_T("file://")), GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0);
		if (hFile == NULL || hFile == INVALID_HANDLE_VALUE) {
		} else {
			BY_HANDLE_FILE_INFORMATION info;

			GetFileInformationByHandle(hFile, &info);

			DWORD cbRead;
			char* buf = (char*)malloc(info.nFileSizeLow);
			ReadFile(hFile, buf, info.nFileSizeLow, &cbRead, 0);

			CloseHandle(hFile);
			if (-1 == gotDataFromUrl(fh, themovie, buf, info.nFileSizeLow, &status)) {
				MSGDEBUG(_T("err in FlashParse"));
			}

			if (buf) free(buf);
		}
	} else {
		IStream * pStream;
		IBindCtx * pBindCtx;

		MSGDEBUG(_T("CreateBindCtx"));
		hr = CreateBindCtx(0, &pBindCtx);
		if (SUCCEEDED(hr) && !pBindCtx)
			MSGDEBUG(_T("CreateBindCtx failed"));

		MSGDEBUG(_T("BindToStorage"));

		int curPtr = 0;
		int curSize = 0;

		if (SUCCEEDED(pMk->BindToStorage(pBindCtx, NULL, IID_IStream, (void**)&pStream))) {
			while (TRUE) {
				DWORD cbRead = 0;
				if (buffer) {
					curSize += BUFBLOCKSIZE;
					buffer = (char*)realloc(buffer, curSize);
				} else {
					buffer = (char*)malloc(BUFBLOCKSIZE);
					curSize = BUFBLOCKSIZE;
				}

				if (FAILED(pStream->Read(buffer + curPtr, curSize - curPtr, &cbRead))) {
					MSGDEBUG(_T("Read failed"));
					break;
				}

				if (cbRead == 0) {
					break;
				}

				curPtr += cbRead;
			}

		} else {
			MSGDEBUG(_T("BindToStorage failed"));
		}

		if (-1 == gotDataFromUrl(fh, themovie, buffer, curPtr, &status)) {
			MSGDEBUG(_T("err in FlashParse"));
		}

		if (buffer) free(buffer);

		pStream->Release();
		pBindCtx->Release();
		pMk->Release();
	}

	CoTaskMemFree((LPVOID)pszDisplayName);

	MSGDEBUG(_T("done loading"));
	FlashGetInfo(fh, &m_fi);
	FlashGraphicInitWin32(fh);
	FlashSoundInit(fh, "/dev/dsp");
	FlashSetGetUrlMethod(fh, g_getUrl, this);
	FlashSetGetSwfMethod(fh, g_getSwf, this);
	
	// global callback is g_getDataFromUrl(this, themovie, &buffer, &size, &status);

	if (status & FLASH_PARSE_NEED_DATA) {
		// error, stream was cut short!
		MSGDEBUG(_T("FLASH_PARSE_NEED_DATA"));
	}
	if (status & FLASH_PARSE_ERROR) {
		// uh oh
		MSGDEBUG(_T("FLASH_PARSE_ERROR"));
	}

	wakeUp = FlashTick(fh, FLASH_WAKEUP, 0, &wd, &framerate);
	SetFocus();

}

void CSparkCtl::SetFlashHandle(FlashHandle fh) {
}



long CSparkCtl::FlashTick(FlashHandle fh, long flag, MSG *event, struct timeval *wakeDate, long *actualFramerate) {
	FlashEvent fe;
	long ret = 0;
	long delayed = GetTickCount();

	if (fh == NULL) return 0;

    if (flag & FLASH_EVENT) {
        // X to Flash event structure conversion
        switch (event->message) {
        case WM_LBUTTONDOWN:
            fe.type = FeButtonPress;
            break;
        case WM_LBUTTONUP:
            fe.type = FeButtonRelease;
            break;
        case WM_MOUSEMOVE:
            fe.type = FeMouseMove;
            fe.x = (int)(SHORT)LOWORD(event->lParam);
            fe.y = (int)(SHORT)HIWORD(event->lParam);
            break;
        case WM_PAINT:
            fe.type = FeRefresh;
            break;
        default:
            fe.type = FeNone;
            break;
        }
    }    
	
	ret = FlashExec(fh, flag, &fe, wakeDate);
	if (actualFramerate) *actualFramerate = GetTickCount() - delayed;
	return ret;
}

void CSparkCtl::FlashBlitWin32(HDC hdc) {
	BitBlt(hdc, m_fd.clip_x, m_fd.clip_y, m_fd.clip_width, m_fd.clip_height, m_bufferdc, m_fd.clip_x, m_fd.clip_y, SRCCOPY);
	
#ifdef DEBUG
	TCHAR szBuf[512];
	SetTextColor(hdc, 0x0);
	SetBkColor(hdc, 0x00FFFFFF);
	SetBkMode(hdc, OPAQUE);
	RECT rt;
	GetClientRect(&rt);

	wsprintf(szBuf, _T("PW:%s\n%s\n%s\n%s\n%s "), m_baseurl, LPCTSTR(m_src), LPCTSTR(m_quality), LPCTSTR(m_scale), LPCTSTR(m_loop));
	DrawText(hdc, szBuf, lstrlen(szBuf), &rt, 0);
#endif
}



// On Wakeup..
LRESULT CSparkCtl::OnWakeup(UINT uMsg, WPARAM wParam, 
                                LPARAM lParam, BOOL& bHandled) 
{
	HDC hdc = GetDC();

	if (m_fd.flash_refresh) {
		m_fd.flash_refresh = 0;
		m_fd.clip_x = 0;
		m_fd.clip_y = 0;
		m_fd.clip_width = m_fd.width;
		m_fd.clip_height = m_fd.height;
		FlashBlitWin32(hdc);
	}

	UINT cmd = FLASH_WAKEUP;
	wakeUp = 1;
	while (wakeUp) {
		MSG mymsg;
		if (flashHandle) wakeUp = FlashTick(flashHandle, cmd, 0, &wd, &framerate);

		if (PeekMessage(&mymsg, m_hWnd, 0, 0, PM_NOREMOVE | PM_NOYIELD)) {
			yieldToMessage = 1;
			break;
		} else {
			if (m_fd.flash_refresh) {
				m_fd.flash_refresh = 0;
				m_fd.clip_x = 0;
				m_fd.clip_y = 0;
				m_fd.clip_width = m_fd.width;
				m_fd.clip_height = m_fd.height;
				FlashBlitWin32(hdc);
			}
		}

		delay = (wd.tv_sec)*1000 + (wd.tv_usec)/1000;  // delay in milliseconds
		delay -= framerate;	// subtract out how long it took to draw last frame, or else we're just waiting around for nothing.
		if (delay <= 0) {
			// go again!
		} else {
			break;
		}

	}

	DoRefresh();

	ReleaseDC(hdc);

	return 0;
}

void CSparkCtl::DoRefresh() 
{
	if (wakeUp) {
		delay = (wd.tv_sec)*1000 + (wd.tv_usec)/1000;  // delay in milliseconds
		delay -= framerate;	// subtract out how long it took to draw last frame, or else we're just waiting around for nothing.
		if (delay <= 0) {
			delay = 1;

			if (yieldToMessage) {
				SetTimer(23, delay);
			} else {
				BOOL b;
				OnTimer(WM_TIMER, 23, 0, b);
			}
		} else {
			SetTimer(23, delay);
		}
		//SetTimer(hwnd, 23, 1, NULL);	// wake now!
	} else {
		// wants a window event, doesnt need ticking.

		// if broken uncomment these
		//delay = (wd.tv_sec)*1000 + (wd.tv_usec)/1000;  // delay in milliseconds
		//SetTimer(hwnd, 23, delay, NULL);
	}
}

LRESULT CSparkCtl::OnTimer(UINT uMsg, WPARAM wParam, 
                                LPARAM lParam, BOOL& bHandled) 
{
	KillTimer(wParam);
	::PostMessage(m_hWnd, WM_FLASHWAKEUP, 0, 0);
	return 0;
}


HRESULT CSparkCtl::OnDraw(ATL_DRAWINFO& di)
{

	if (flashHandle != NULL) {

		RECT& rc = *(RECT*)di.prcBounds;

		m_fd.clip_x = di.prcBounds->left;
		m_fd.clip_y = di.prcBounds->top;
		m_fd.clip_width = di.prcBounds->right - m_fd.clip_x;
		m_fd.clip_height = di.prcBounds->bottom - m_fd.clip_y;

		FlashBlitWin32(di.hdcDraw);

	} else {
		RECT rt;
		rt.top = di.prcBounds->top;
		rt.left = di.prcBounds->left;
		rt.bottom = di.prcBounds->bottom;
		rt.right = di.prcBounds->right;
		FillRect(di.hdcDraw, &rt, (HBRUSH)GetStockObject(WHITE_BRUSH));
		TCHAR szBuf[512];
		wsprintf(szBuf, _T("PW:%s\n%s\n%s\n%s\n%s "), m_baseurl, LPCTSTR(m_src), LPCTSTR(m_quality), LPCTSTR(m_scale), LPCTSTR(m_loop));
#ifdef DEBUG
		DrawText(di.hdcDraw, szBuf, lstrlen(szBuf), &rt, 0);
#endif
		if (m_hWnd) {
			// this is a horrendous severe hack!
			// 4762 3175 for a 180 120 window...
			//wsprintf(szBuf, _T("doing it but %dx%d"), this->m_sizeExtent.cx, this->m_sizeExtent.cy);
			//MessageBox(szBuf);
			GetClientRect(&rt);
			if (rt.bottom == 0 && rt.top == 0) {
				rt.top = di.prcBounds->top;
				rt.left = di.prcBounds->left;
				rt.bottom = di.prcBounds->bottom;
				rt.right = di.prcBounds->right;

				SetWindowPos(0, &rt, SWP_NOZORDER);
				PostMessage(WM_FLASHINITIALIZE);
			}

		}
	}


	return S_OK;
}
 

#define _ASSERT(x) if (!(x)) MSGDEBUG(L" ## (x) ## ", _T("Assert failed"), MB_SETFOREGROUND);

LRESULT CSparkCtl::SetClientSite(IOleClientSite *pClientSite) {
	// IE4
	if (pClientSite) {
		IServiceProvider *pISP;
		IWebBrowser2 *pIWebBrowser2;
		pClientSite->QueryInterface(IID_IServiceProvider,
					  (void **)&pISP); 
		if (pISP) {
			pISP->QueryService(IID_IWebBrowserApp, IID_IWebBrowser2,
			 (void **)&pIWebBrowser2); 			

			if (pIWebBrowser2) {
				pIWebBrowser2->get_LocationURL(&m_baseurl);
				m_pWebBrowser2 = pIWebBrowser2;
			}
		}	
	}

	HRESULT hr = IOleObjectImpl<CSparkCtl>::SetClientSite(pClientSite); 

	if (SUCCEEDED(hr) && pClientSite)
	{
		// Get the container's window.
		_ASSERT(m_spClientSite);

		LPOLEINPLACESITE pInPlaceSite = NULL;
		hr = m_spClientSite->QueryInterface(IID_IOleInPlaceSite,
		(void **)&pInPlaceSite);

		_ASSERT(SUCCEEDED(hr) && pInPlaceSite);

		HWND hParent = NULL;
		hr = pInPlaceSite->GetWindow(&hParent);

		_ASSERT(SUCCEEDED(hr) && hParent);

		//pInPlaceSite->Release();

		// Set container window as our parent window
		// Window will be resized correctly during in-place
		// activation.

		RECT rcPos = { 0, 0, 0, 0};

		HWND hWnd = CreateControlWindow(hParent/*::GetDesktopWindow()*/, rcPos);

		_ASSERT(hWnd);
		hWnd;

	}

	//PostMessage(WM_FLASHINITIALIZE);

	return hr;
   
}

HRESULT CSparkCtl::InPlaceActivate(LONG iVerb, const RECT* prcPosRect)
{
	// Get the container's window.
	_ASSERT (m_spClientSite);

	LPOLEINPLACESITE pInPlaceSite = NULL;
	HRESULT hr = m_spClientSite->QueryInterface(IID_IOleInPlaceSite,
	(void **)&pInPlaceSite);

	_ASSERT (SUCCEEDED(hr) && pInPlaceSite);

	HWND hParent = NULL;
	hr = pInPlaceSite->GetWindow(&hParent);

	_ASSERT (SUCCEEDED(hr) && hParent);

	pInPlaceSite->Release();

	// Set container window as our parent window
	SetParent(hParent);

	TCHAR szBuf[128] = { 0 };
	if (prcPosRect) 
		wsprintf(szBuf, _T("%d, %d, %d, %d"),
		prcPosRect->left, prcPosRect->top, prcPosRect->right, prcPosRect->bottom);
//	MessageBox(szBuf, _T("InPlaceActivate"), MB_OK);

	return CComControlBase::InPlaceActivate(iVerb, prcPosRect);
}





LRESULT CSparkCtl::SetSite(IUnknown *pSite)
{
	// PIE
   if (pSite != NULL) {
		IBrowser *pBrowser = NULL;
		pSite->QueryInterface(IID_IBrowser, (void**)&pBrowser);
		if (pBrowser) {
			pBrowser->get_LocationURL(&m_baseurl);

			m_pBrowser = pBrowser;
		}
	}

	m_spUnkSite = pSite;
	return S_OK;
} 


LRESULT CSparkCtl::OnCreate(UINT uMsg, WPARAM wParam, 
                                LPARAM lParam, BOOL& bHandled) {

	HRESULT hr;
	m_pBrowser = NULL;

	if (flashHandle != NULL) {
	//	FlashClose(flashHandle);
		flashHandle = NULL;
	}

	MSGDEBUG(_T("SPARK OnCreate"));

	PostMessage(WM_FLASHINITIALIZE);

	InvalidateRect(NULL, FALSE);


	bHandled = FALSE;

	return S_OK;
}


LRESULT CSparkCtl::OnInitialize(UINT uMsg, WPARAM wParam, 
                                LPARAM lParam, BOOL& bHandled) {
	m_didInitialize = TRUE;
	MSGDEBUG(_T("OnInitialize"));

	if (flashHandle == NULL) {
		MSGDEBUG(_T("loading movie"));

		RECT wattr;
		GetClientRect(&wattr);
		if (wattr.bottom != 0 && wattr.right != 0) {
			// PIE!

			m_level = 0;
			loadMovie(m_src);
			::PostMessage(m_hWnd, WM_FLASHWAKEUP, 0, 0);
		} else {
			InvalidateRect(NULL, TRUE);
		}
	}

	return S_OK;
}


void CSparkCtl::DoMouseEvent(UINT uMsg, WPARAM wParam, 
                                LPARAM lParam) {
	MSG event;
	event.hwnd = m_hWnd;
	event.message = uMsg;
	event.lParam = lParam;
	event.wParam = wParam;
	event.pt.x = LOWORD(lParam);
	event.pt.y = HIWORD(lParam);
	event.time = GetTickCount() - 1;

	if ((flashHandle) && FlashTick(flashHandle, FLASH_EVENT, &event, &wd, &framerate))
		wakeUp = 1;
}

LRESULT CSparkCtl::OnLButtonDown(UINT uMsg, WPARAM wParam, 
                                LPARAM lParam, BOOL& bHandled) 
{
	HWND hWnd;
	hWnd = ::SetCapture(m_hWnd);

	// linux flashlib (or X) is weird -- need to set a mousemove event before a ButtonPress:
	DoMouseEvent(WM_MOUSEMOVE, wParam, lParam);
	DoRefresh();
	DoMouseEvent(uMsg, wParam, lParam);
	DoRefresh();
	return 0;

}


LRESULT CSparkCtl::OnLButtonUp(UINT uMsg, WPARAM wParam, 
                                LPARAM lParam, BOOL& bHandled) 
{ 
	/*
	IUnknown * pUnk = NULL;

	UINT pWM_ATLGETHOST = RegisterWindowMessage(_T("WM_ATLGETHOST"));
	UINT pWM_ATLGETCONTROL = RegisterWindowMessage(_T("WM_ATLGETCONTROL"));

	if (!pUnk) MessageBox(_T("0"), _T(""), MB_SETFOREGROUND);
	if (pWM_ATLGETHOST) MessageBox(_T("pWM_ATLGETHOST"), _T(""), MB_SETFOREGROUND);
	if (pWM_ATLGETCONTROL) MessageBox(_T("pWM_ATLGETCONTROL"), _T(""), MB_SETFOREGROUND);

	pUnk = NULL;
	AtlAxGetHost(m_hWnd, &pUnk);
	if (pUnk) MessageBox(_T("1"), _T(""), MB_SETFOREGROUND);
	pUnk = NULL;
	AtlAxGetControl(m_hWnd, &pUnk);
	if (pUnk) MessageBox(_T("21"), _T(""), MB_SETFOREGROUND);
	pUnk = NULL;
	AtlAxGetHost(GetParent(), &pUnk);
	if (pUnk) MessageBox(_T("31"), _T(""), MB_SETFOREGROUND);
	pUnk = NULL;
	AtlAxGetControl(GetParent(), &pUnk);
	if (pUnk) MessageBox(_T("41"), _T(""), MB_SETFOREGROUND);
	pUnk = NULL;
	AtlAxGetHost(::GetParent(GetParent()), &pUnk);
	if (pUnk) MessageBox(_T("51"), _T(""), MB_SETFOREGROUND);
	pUnk = NULL;
	AtlAxGetControl(::GetParent(GetParent()), &pUnk);
	if (pUnk) MessageBox(_T("61"), _T(""), MB_SETFOREGROUND);
	if (!pUnk) MessageBox(_T("0"), _T(""), MB_SETFOREGROUND);
	*/

	ReleaseCapture();
	DoMouseEvent(uMsg, wParam, lParam);
	DoRefresh();
	return 0;
}


LRESULT CSparkCtl::OnMouseMove(UINT uMsg, WPARAM wParam, 
                                LPARAM lParam, BOOL& bHandled) 
{ 
	DoMouseEvent(uMsg, wParam, lParam);
	DoRefresh();
	return 0;

	/*
	static BOOL bThere = FALSE;

	if ((::GetCapture() == m_hWnd) )
	{
		if (LOWORD(lParam) < 65000 && HIWORD(lParam) < 65000)
		{
			if (bThere)
			{
				bThere = FALSE;
				line[0].x = LOWORD(lParam);
				line[0].y = HIWORD(lParam);
			}
			else
			{
				line[1].x = LOWORD(lParam);
				line[1].y = HIWORD(lParam);
				if ( (line[0].x != line[1].x || line[0].y != line[1].y) )
				{
					HDC hdc = GetDC();
					SelectObject(hdc, CreatePen(PS_SOLID, (m_PenWidth - 1), 0));

					Polyline(hdc, line, 2);
					line[0] = line[1];
					ReleaseDC(hdc);
				}
			}
		}
		else
		{
			bThere = TRUE;
		}
	}
	return 0;    
	*/
} 


STDMETHODIMP CSparkCtl::Erase()
{
	HDC hdc = GetDC();
	Rectangle(hdc, left, top, right, bottom);
	ReleaseDC(hdc);
	return S_OK;
}
