// SparkCtl.h : Declaration of the CSparkCtl

#ifndef __SPARKCTL_H_
#define __SPARKCTL_H_

#include "resource.h"       // main symbols
#include "webview.h"

#include "../flash-0.4.3/lib/flash.h"
//#include "ceCString.h"

struct timeval {
    long tv_sec;
    long tv_usec;
};
#define WM_FLASHCREATE	(WM_USER+500)
#define WM_FLASHWAKEUP	(WM_USER+501)
#define WM_SETFLASHHANDLE (WM_USER+502)
#define WM_UNLOADFLASH (WM_USER+503)
#define WM_FILEDROPPED (WM_USER+504)
#define WM_EVERYTHINGLOADED (WM_USER+505)
#define WM_FLASHINITIALIZE	(WM_USER+506)

#ifdef DEBUG
#define MSGDEBUG(x) ::MessageBox(NULL, (x), _T("Debug"), MB_SETFOREGROUND)
#ifdef ATLTRACE
#undef ATLTRACE
#endif
#define ATLTRACE MSGDEBUG
#else
#define MSGDEBUG
#endif

template <class T>
   class ATL_NO_VTABLE CMyObjectSafety
   {
   public:
   // Pass in supported safety options, e.g.
   // INTERFACESAFE_FOR_UNTRUSTED_CALLER - safe for scripting
   // INTERFACESAFE_FOR_UNTRUSTED_DATA - safe for initialization from data
   CMyObjectSafety(DWORD dwSupportedSafety = INTERFACESAFE_FOR_UNTRUSTED_CALLER | INTERFACESAFE_FOR_UNTRUSTED_DATA)
   {
      m_dwCurrentSafety = dwSupportedSafety;
      m_dwSupportedSafety = dwSupportedSafety;
   }
 
   // IUnknown
   //
   STDMETHOD(QueryInterface)(REFIID riid, void** ppvObject) = 0;
   _ATL_DEBUG_ADDREF_RELEASE_IMPL(CMyObjectSafety)
 
   // IObjectSafety
   //
   STDMETHOD(GetInterfaceSafetyOptions)
      (REFIID riid, DWORD *pdwSupportedOptions, DWORD *pdwEnabledOptions)
   {
      T* pT = (T*)this;
      if (pdwSupportedOptions == NULL || pdwEnabledOptions == NULL)
         return E_POINTER;
      
      HRESULT hr;
      IUnknown* pUnk;
      // Check if we support this interface
      hr = pT->GetUnknown()->QueryInterface(riid, (void**)&pUnk);
      if (SUCCEEDED(hr))
      {
		  TCHAR szDebug[64];
		  wsprintf(szDebug, _T("GetInterfaceSafetyOptions:: %#x,%#x"), m_dwSupportedSafety, m_dwCurrentSafety);
        // We support this interface so set the safety options accordingly
         pUnk->Release();   // Release the interface we just acquired
         *pdwSupportedOptions = m_dwSupportedSafety;
         *pdwEnabledOptions = m_dwCurrentSafety;
      }
      else
      {
 	      //ATLTRACE(_T("else::GetInterfaceSafetyOptions\n"));
        // We don't support this interface
         *pdwSupportedOptions = 0;
         *pdwEnabledOptions = 0;
      }
      return hr;
   }
   STDMETHOD(SetInterfaceSafetyOptions)
      (REFIID riid, DWORD dwOptionSetMask, DWORD dwEnabledOptions)
   {
      ATLTRACE(_T("CMyObjectSafety::SetInterfaceSafetyOptions\n"));
      T* pT = (T*)this;
      IUnknown* pUnk;
      
      // Check if we support the interface and return E_NOINTEFACE if we don't
      if (FAILED(pT->GetUnknown()->QueryInterface(riid, (void**)&pUnk)))
         return E_NOINTERFACE;
      pUnk->Release();   // Release the interface we just acquired
      
      // If we are asked to set options we don't support then fail
      if (dwOptionSetMask & ~m_dwSupportedSafety)
         return E_FAIL;
 
      // Set the safety options we have been asked to
      m_dwCurrentSafety = m_dwCurrentSafety & ~dwEnabledOptions | 
         dwOptionSetMask;
      return S_OK;
   }
   DWORD m_dwCurrentSafety;
   DWORD m_dwSupportedSafety;
   }; 

/////////////////////////////////////////////////////////////////////////////
// CSparkCtl
class ATL_NO_VTABLE CSparkCtl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ISparkCtl, &IID_ISparkCtl, &LIBID_SPARKLib>,
	public CComControl<CSparkCtl>,

	public IPersistStreamInitImpl<CSparkCtl>,
	public IOleControlImpl<CSparkCtl>,
	public IOleObjectImpl<CSparkCtl>,
	public IOleInPlaceActiveObjectImpl<CSparkCtl>,
	public IViewObjectExImpl<CSparkCtl>,
	public IOleInPlaceObjectWindowlessImpl<CSparkCtl>,

	public IPersistStorageImpl<CSparkCtl>,
	public ISpecifyPropertyPagesImpl<CSparkCtl>,
	public IQuickActivateImpl<CSparkCtl>,
	public IDataObjectImpl<CSparkCtl>,
	public IProvideClassInfo2Impl<&CLSID_SparkCtl, NULL, &LIBID_SPARKLib>,
	public IPersistPropertyBagImpl<CSparkCtl>,
	public CMyObjectSafety<CSparkCtl>,

//	public ISupportErrorInfo,
	public IObjectWithSiteImpl<CSparkCtl>,

	public CComCoClass<CSparkCtl, &CLSID_SparkCtl>
{
public:
	CSparkCtl()
	{
		MSGDEBUG(_T("ctor"));

		bLBDown = FALSE; 
		m_bWndLess = FALSE;
		m_bWindowOnly = TRUE;
		m_PenWidth = 1;
		m_zoom = 20;
		m_level = 0;
		m_didInitialize = FALSE;
		m_enableInPlaceActivation = FALSE;
		//CComControl<CSparkCtl>::InPlaceActivate(OLEIVERB_SHOW);
	}
	~CSparkCtl()
	{
		MSGDEBUG(_T("dtor"));

		if (flashHandle) {
			FlashClose(flashHandle);
		}

		if (m_hWnd != NULL) {
			if (::IsWindow(m_hWnd)) {
				::DestroyWindow(m_hWnd);
			}
			m_hWnd = NULL;
		}
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SPARKCTL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSparkCtl)
	COM_INTERFACE_ENTRY(ISparkCtl)
	COM_INTERFACE_ENTRY(IDispatch)

	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)

	COM_INTERFACE_ENTRY_IMPL(IOleControl)
	COM_INTERFACE_ENTRY_IMPL(IOleObject)
//	COM_INTERFACE_ENTRY_IMPL(IViewObjectEx)
//	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject2, IViewObjectEx)
//	COM_INTERFACE_ENTRY_IMPL_IID(IID_IViewObject, IViewObjectEx)

//	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
//	COM_INTERFACE_ENTRY_IMPL_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
//	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceActiveObject)
//	COM_INTERFACE_ENTRY_IMPL(IOleInPlaceObjectWindowless)

	COM_INTERFACE_ENTRY_IMPL(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY_IMPL(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY_IMPL(IQuickActivate)
	COM_INTERFACE_ENTRY_IMPL(IPersistStorage)
	COM_INTERFACE_ENTRY_IMPL(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
//	COM_INTERFACE_ENTRY(ISupportErrorInfo)

	COM_INTERFACE_ENTRY_IMPL(IPersistPropertyBag)
	COM_INTERFACE_ENTRY_IMPL(IObjectWithSite)
	COM_INTERFACE_ENTRY_IID(IID_IObjectSafety, CMyObjectSafety<CSparkCtl>)
END_COM_MAP()


BEGIN_PROPERTY_MAP(CSparkCtl)
	PROP_ENTRY("PenWidth", 1, CLSID_SparkCtl)
	PROP_ENTRY("Src", 3, CLSID_SparkCtl)
	PROP_ENTRY("Quality", 4, CLSID_SparkCtl)
	PROP_ENTRY("Scale", 5, CLSID_SparkCtl)
	PROP_ENTRY("Loop", 6, CLSID_SparkCtl)
	PROP_ENTRY("BaseURL", 7, CLSID_SparkCtl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
END_PROPERTY_MAP()


BEGIN_CATEGORY_MAP(CSparkCtl)
	IMPLEMENTED_CATEGORY(CATID_SafeForScripting)
	IMPLEMENTED_CATEGORY(CATID_SafeForInitializing)
END_CATEGORY_MAP()


BEGIN_MSG_MAP(CSparkCtl)
	if (m_fd.flash_refresh) {
		m_fd.flash_refresh = 0;
		HDC hdc = GetDC();
		FlashBlitWin32(hdc);
		ReleaseDC(hdc);
	}
	//MESSAGE_HANDLER(WM_FLASHCREATE, OnCreate)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_KILLFOCUS, OnKillFocus)
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
	MESSAGE_HANDLER(WM_LBUTTONUP, OnLButtonUp)
	MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove)
	MESSAGE_HANDLER(WM_FLASHINITIALIZE, OnInitialize)
	MESSAGE_HANDLER(WM_FLASHWAKEUP, OnWakeup)
	MESSAGE_HANDLER(WM_TIMER, OnTimer)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	//MESSAGE_HANDLER(WM_LBUTTONDBLCLK, OnRButtonDown)
	CHAIN_MSG_MAP(CComControl<CSparkCtl>)
END_MSG_MAP()
 

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IViewObjectEx
	STDMETHOD(GetViewStatus)(DWORD* pdwStatus)
	{
	//	ATLTRACE(_T("IViewObjectExImpl::GetViewStatus\n"));
		*pdwStatus = VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE;
		return S_OK;
	}

// ISparkCtl
public:
	// IPersistPropertyBag
	STDMETHOD(Load2)(IPropertyBag *pPropBag, IErrorLog *pErrorLog);
	STDMETHOD(Save2)(LPPROPERTYBAG pPropBag, BOOL fClearDirty, BOOL fSaveAllProperties);


	STDMETHOD(Erase)();
	STDMETHOD(get_PenWidth)(short *pval);
	STDMETHOD(put_PenWidth)(short newVal);
	STDMETHOD(get_Src)(BSTR * p);
	STDMETHOD(put_Src)(BSTR v);
	STDMETHOD(get_Quality)(BSTR * p);
	STDMETHOD(put_Quality)(BSTR v);
	STDMETHOD(get_Scale)(BSTR * p);
	STDMETHOD(put_Scale)(BSTR v);
	STDMETHOD(get_Loop)(BSTR * p);
	STDMETHOD(put_Loop)(BSTR v);
	STDMETHOD(get_BaseURL)(BSTR * p);
	STDMETHOD(put_BaseURL)(BSTR v);

	STDMETHOD(SetSite)(IUnknown *pSite);
	STDMETHOD(SetClientSite)(IOleClientSite *pClientSite);
	HRESULT InPlaceActivate(LONG iVerb, const RECT* prcPosRect);

	STDMETHOD(DoVerb)(LONG iVerb, LPMSG pMsg , IOleClientSite* pActiveSite , LONG lindex ,
		HWND hwndParent, LPCRECT lprcPosRect) {

		if (lprcPosRect) {
			int cx, cy;
			cx = lprcPosRect->right - lprcPosRect->left;
			cy = lprcPosRect->bottom - lprcPosRect->top;
			TCHAR szBuf[64];
			wsprintf(szBuf, _T("cx=%d cy=%d"), cx, cy);
			//if (cx || cy) ::MessageBox(NULL, szBuf, _T("DoVerb"), MB_SETFOREGROUND);
		}


		return IOleObjectImpl<CSparkCtl>::DoVerb(iVerb, pMsg, pActiveSite, lindex, hwndParent, lprcPosRect);

	}

	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip)
	{
		IOleInPlaceObjectWindowlessImpl<CSparkCtl>::SetObjectRects(prcPos, prcClip);
		int cx, cy;
		cx = prcPos->right - prcPos->left;
		cy = prcPos->bottom - prcPos->top;
		//::SetWindowPos(m_ctlButton.m_hWnd, NULL, 0,
		//	0, cx, cy, SWP_NOZORDER | SWP_NOACTIVATE);
		TCHAR szBuf[64];
		wsprintf(szBuf, _T("cx=%d cy=%d"), cx, cy);
		//::MessageBox(NULL, szBuf, _T("SetObjectRects"), MB_SETFOREGROUND);
		return S_OK;
	}

	LRESULT OnSetFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		LRESULT lRes = CComControl<CSparkCtl>::OnSetFocus(uMsg, wParam, lParam, bHandled);
		if (m_bInPlaceActive)
		{
			DoVerbUIActivate(&m_rcPos,  NULL);
		}
		return lRes;
	}

	LRESULT OnInitialize(UINT uMsg, WPARAM wParam, 
	                               LPARAM lParam, BOOL& bHandled);
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam,
								BOOL& bHandled); 
	HRESULT OnDraw(ATL_DRAWINFO& di);
	LRESULT OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam,
								BOOL& bHandled); 
	LRESULT OnLButtonUp(UINT uMsg, WPARAM wParam, LPARAM lParam,
				                  BOOL& bHandled); 
	LRESULT OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam,
				                  BOOL& bHandled); 
	LRESULT OnWakeup(UINT uMsg, WPARAM wParam, LPARAM lParam,
				                  BOOL& bHandled); 
	LRESULT OnTimer(UINT uMsg, WPARAM wParam, LPARAM lParam,
				                  BOOL& bHandled); 
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam,
		BOOL& bHandled) {
		MSGDEBUG(_T("OnDestroy"));
		if (flashHandle) {
			FlashClose(flashHandle);
		}
		bHandled = FALSE;

		return S_OK;
	}

	void SetFlashHandle(FlashHandle fh);
	long FlashTick(FlashHandle fh, long flag, MSG *event, struct timeval *wakeDate, long *actualFramerate);
	void FlashBlitWin32(HDC hdc);
	long FlashGraphicInitWin32(FlashHandle flashHandle);
	int	gotDataFromUrl(FlashHandle fh, LPCTSTR url, char*buffer, long size, int* lpstatus);
	void loadMovie(LPCTSTR themovie);
	void getUrl(char* url, char* target);
	void getSwf(char *url, int level);
	void DoRefresh();
	void DoMouseEvent(UINT uMsg, WPARAM wParam, 
                                LPARAM lParam);
	
	BOOL m_enableInPlaceActivation;
	BOOL bLBDown;
	BOOL m_didInitialize;
	POINT line[2];
	int left, right, top, bottom;
	short m_PenWidth;

	struct timeval wd,de,now;
	long delay;
	long wakeUp;
	long yieldToMessage;
	long m_zoom;
	long m_xoffs;
	long m_yoffs;
	long framerate;
	FlashHandle flashHandle;
	BOOL eatMouseDown;
	BOOL eatMouseUp;
    FlashDisplay m_fd;
	FlashInfo m_fi;
	HBITMAP		 m_hbmpBuffer;
    HDC		 	 m_bufferdc;		// X11 Graphic context

	IBrowser * m_pBrowser;
	IWebBrowser2 * m_pWebBrowser2;
	CComBSTR m_src;
	CComBSTR m_quality;
	CComBSTR m_loop;
	CComBSTR m_scale;
	CComBSTR m_baseurl;
	int m_level;
};

#endif //__SPARKCTL_H_
