#ifndef EXDISPID_H_
//+-------------------------------------------------------------------------
//
//  Microsoft Windows
//  Copyright 1995 - 1996 Microsoft Corporation. All Rights Reserved.
//
//  File: exdispid.h
//
//--------------------------------------------------------------------------


//
// Dispatch IDS for IExplorer Dispatch Events.
//
#define DISPID_BEFORENAVIGATE           100   // this is sent before navigation to give a chance to abort
#define DISPID_NAVIGATECOMPLETE         101   // in async, this is sent when we have enough to show
#define DISPID_STATUSTEXTCHANGE         102
#define DISPID_QUIT                     103
#define DISPID_DOWNLOADCOMPLETE         104
#define DISPID_COMMANDSTATECHANGE       105
#define DISPID_DOWNLOADBEGIN            106
#define DISPID_NEWWINDOW                107   // sent when a new window should be created
#define DISPID_PROGRESSCHANGE           108   // sent when download progress is updated
#define DISPID_WINDOWMOVE               109   // sent when main window has been moved
#define DISPID_WINDOWRESIZE             110   // sent when main window has been sized
#define DISPID_WINDOWACTIVATE           111   // sent when main window has been activated
#define DISPID_PROPERTYCHANGE           112   // sent when the PutProperty method is called
#define DISPID_TITLECHANGE              113   // sent when the document title changes
#define DISPID_REQUESTNAVIGATE          114   // sent to request that the explorer call Navigate on a specified string

#define DISPID_BROWSERNAVIGATE          150
#define DISPID_BROWSERREFRESH           151
#define DISPID_BROWSERSTOP              152
#define DISPID_BROWSERBUSY              153
#define DISPID_BROWSERTITLE             154
#define DISPID_BROWSERLOCATION          155
#define DISPID_BROWSERISFRAME           156
#define DISPID_BROWSERSCROLLSTYLE       157
#define DISPID_BROWSERMARGINWIDTH       158
#define DISPID_BROWSERMARGINHEIGHT      159
#define DISPID_BROWSERFRAMENAVIGATE     160
#define DISPID_BROWSERSELECTEDCODEPAGE  161
#define DISPID_BROWSERPOINTER           162

#define DISPID_BROWSERLAYOUTWIDTH       175
#define DISPID_BROWSERLAYOUTHEIGHT      176
#define DISPID_BROWSERLOCATIONBASEURL   177
#define DISPID_BROWSERCLEARTYPEENABLED  178
#define DISPID_BROWSERSCRIPTINGENABLED  179
#define DISPID_BROWSERFITTOWINDOW       180
#define DISPID_BROWSERSHOWIMAGES        181
#define DISPID_BROWSERPLAYSOUNDS        182
#define DISPID_BROWSERZOOMLEVEL         183

#define DISPID_FRAMEBEFORENAVIGATE      200
#define DISPID_FRAMENAVIGATECOMPLETE    201
#define DISPID_FRAMENEWWINDOW           204

#define DISPID_ONSTATUSBAR              257
#define DISPID_DOCUMENTCOMPLETE         259   // new document goes ReadyState_Complete

#define DISPID_ONHISTORYLIMITCHANGE     262   // send when the history limit has been updated or the 'clear history' button has been pressed.

#define EXDISPID_H_
#endif // EXDISPID_H_
